org.apache.lucene.index

## Class FilterAtomicReader.FilterDocsAndPositionsEnum

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.DocsEnum
    - - org.apache.lucene.index.DocsAndPositionsEnum
      - - org.apache.lucene.index.FilterAtomicReader.FilterDocsAndPositionsEnum

Enclosing class:
  FilterAtomicReader

    public static class FilterAtomicReader.FilterDocsAndPositionsEnum
    extends DocsAndPositionsEnum

Base class for filtering `DocsAndPositionsEnum` implementations.

### Field Summary

Fields
`protected DocsAndPositionsEnum` `in` The underlying DocsAndPositionsEnum instance.

### Fields inherited from class org.apache.lucene.index.DocsAndPositionsEnum

`FLAG_OFFSETS, FLAG_PAYLOADS`

### Fields inherited from class org.apache.lucene.index.DocsEnum

`FLAG_FREQS, FLAG_NONE`

### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

`NO_MORE_DOCS`

### Constructor Summary

Constructors
Constructor and Description
`FilterAtomicReader.FilterDocsAndPositionsEnum(DocsAndPositionsEnum in)` Create a new FilterDocsAndPositionsEnum

### Method Summary

Methods
`int` `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
`AttributeSource` `attributes()` Returns the related attributes.
`int` `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`int` `endOffset()` Returns end offset for the current position, or -1 if offsets were not indexed.
`int` `freq()` Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`.
`BytesRef` `getPayload()` Returns the payload at this position, or null if no payload was indexed.
`int` `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
`int` `nextPosition()` Returns the next position.
`int` `startOffset()` Returns start offset for the current position, or -1 if offsets were not indexed.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### in

    protected final DocsAndPositionsEnum in

The underlying DocsAndPositionsEnum instance.

### Constructor Detail

#### FilterAtomicReader.FilterDocsAndPositionsEnum

    public FilterAtomicReader.FilterDocsAndPositionsEnum(DocsAndPositionsEnum in)

Create a new FilterDocsAndPositionsEnum

Parameters:
  `in` - the underlying DocsAndPositionsEnum instance.

### Method Detail

#### docID

    public int docID()

Description copied from class: `DocIdSetIterator`
Returns the following:

- -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
- `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
- Otherwise it should return the doc ID it is currently on.

Specified by:
  `docID` in class `DocIdSetIterator`

#### freq

    public int freq()
             throws IOException

Description copied from class: `DocsEnum`
Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`. Do not call this before `DocIdSetIterator.nextDoc()` is first called, nor after `DocIdSetIterator.nextDoc()` returns `DocIdSetIterator.NO_MORE_DOCS`.

NOTE: if the `DocsEnum` was obtain with `DocsEnum.FLAG_NONE`, the result of this method is undefined.

Specified by:
  `freq` in class `DocsEnum`
Throws:
  `IOException`

#### nextDoc

    public int nextDoc()
                throws IOException

Description copied from class: `DocIdSetIterator`
Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

Specified by:
  `nextDoc` in class `DocIdSetIterator`
Throws:
  `IOException`

#### advance

    public int advance(int target)
                throws IOException

Description copied from class: `DocIdSetIterator`
Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

When `target > current` it behaves as if written:

     int advance(int target) {
       int doc;
       while ((doc = nextDoc()) < target) {
       }
       return doc;
     }

Some implementations are considerably more efficient than that.

NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

Specified by:
  `advance` in class `DocIdSetIterator`
Throws:
  `IOException`

#### nextPosition

    public int nextPosition()
                     throws IOException

Description copied from class: `DocsAndPositionsEnum`
Returns the next position. You should only call this up to `DocsEnum.freq()` times else the behavior is not defined. If positions were not indexed this will return -1; this only happens if offsets were indexed and you passed needsOffset=true when pulling the enum.

Specified by:
  `nextPosition` in class `DocsAndPositionsEnum`
Throws:
  `IOException`

#### startOffset

    public int startOffset()
                    throws IOException

Description copied from class: `DocsAndPositionsEnum`
Returns start offset for the current position, or -1 if offsets were not indexed.

Specified by:
  `startOffset` in class `DocsAndPositionsEnum`
Throws:
  `IOException`

#### endOffset

    public int endOffset()
                  throws IOException

Description copied from class: `DocsAndPositionsEnum`
Returns end offset for the current position, or -1 if offsets were not indexed.

Specified by:
  `endOffset` in class `DocsAndPositionsEnum`
Throws:
  `IOException`

#### getPayload

    public BytesRef getPayload()
                        throws IOException

Description copied from class: `DocsAndPositionsEnum`
Returns the payload at this position, or null if no payload was indexed. You should not modify anything (neither members of the returned BytesRef nor bytes in the byte[]).

Specified by:
  `getPayload` in class `DocsAndPositionsEnum`
Throws:
  `IOException`

#### attributes

    public AttributeSource attributes()

Description copied from class: `DocsEnum`
Returns the related attributes.

Overrides:
  `attributes` in class `DocsEnum`